#include "blind.h"
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <linux/fb.h>
#include "collie_frontlight.h"

#include <qpushbutton.h>
#include <qpe/qpeapplication.h>

/* 
 *  Constructs a BlindMain which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
BlindMain::BlindMain( QWidget* parent,  const char* name, WFlags fl )
    : UIMainWindow( parent, name, fl )
{
				fdlcd = -1;
				fdfl = -1;

				_sltBlank();
				// QPEApplication::grabKeyboard();
				grabKeyboard();

}

/*  
 *  Destroys the object and frees any allocated resources
 */
BlindMain::~BlindMain()
{
				releaseKeyboard();
				// QPEApplication::ungrabKeyboard();
				// Unblind
				if ( fdlcd >= 0 ) {
					ioctl( fdlcd, FBIOBLANK, 0 );			// Turn off the lcd
					::close(fdlcd);
				}
				if ( fdfl >= 0 ) {
					ioctl( fdfl, COLLIE_FL_IOCTL_ON );
					::close(fdfl);
				}

}

void
BlindMain::_sltBlank() {
#if 1
				if ( fdlcd < 0 ) 
						fdlcd = open( "/dev/fb0", O_RDWR );
				if ( fdfl < 0 )
						fdfl = open( "/dev/fl", O_RDWR );

				if ( fdlcd < 0 ) {
					fprintf( stderr, "Cannot open /dev/fb0\n" );
					return;
				}
				if ( fdfl < 0 ) {
					fprintf( stderr, "Cannot open /dev/fl\n" );
					return;
				}
				// check open
				ioctl( fdlcd, FBIOBLANK, 1 );			// Turn off the lcd
				ioctl( fdfl, COLLIE_FL_IOCTL_OFF );
#endif

}

void
BlindMain::keyPressEvent( QKeyEvent * ) {
	qDebug( "key pressed\n" );
	close( true );			// close and delete
}
